/* Problem URL: https://codeforces.com/contest/2155/problem/C */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vl fds(n);
        cin >> fds;

        if (n == 1) {
            cout << (fds[0] == 1 ? "2\n" : "0\n");
            continue;
        }
        
        vi diffs(n - 1);
        int maximal = 0;
        rep(i, n - 1) {
            diffs[i] = fds[i] - fds[i + 1];
            rmax(maximal, abs(diffs[i]));
        }

        if (maximal >= 2) {
            cout << "0\n";
            continue;
        }

        auto findans = [&](int s) {
            vi ans(n);
            ans[0] = s;

            vvi act(n, vi(2));
            act[0][s] = 1;

            nrep(i, 1, n) {
                if (diffs[i - 1] == 0) {
                    ans[i] = ans[i - 1] ^ 1;
                    act[i][ans[i]] = 1;
                    continue;
                }

                if (diffs[i - 1] < 0) {
                    if (ans[i - 1] != 0) {
                        return 0;
                    }
                    act[i][0] = 1;
                    continue;
                }

                if (ans[i - 1] != 1) {
                    return 0;
                }

                ans[i] = 1;
                act[i][1] = 1;
            }

            nrep(i, 1, n) {
                act[i][0] += act[i - 1][0];
                act[n - i - 1][1] += act[n - i][1];
            }

            rep(i, n) {
                if (fds[i] != act[i][0] + act[i][1]) {
                    return 0;
                }
            }

            return 1;
        };
        
        cout << findans(0) + findans(1) << '\n';
    }
}
